/* Keyboard driver for interpreter. Takes input one line at a time
   from stdin , generates a program vector and executes it .Loops
   until EOF. Note: Due to an apparent bug in the Venix i/o driver,
   EOF (ctrl-d) is ignored unless it is the first character in
   a line */
#include <signal.h>
#include <stdio.h>
#include "idecls.h"
char line[MAXLINE+1] ;
main()
{
	register int len;
	register char *ep;
	int next;
	char *iparse();
	int sabrti(), sabrtos();
	entry_ptr pv[50] ;
	abrt = NORMAL;
	signal(SIGINT, sabrti);
	signal(SIGQUIT, sabrtos);
	st_init();
	while (abrt != OSABORT) 
	{
		abrt = NORMAL;
		delete() ;
		printf ("*");
		if ((len=getline(stdin,line,MAXLINE)) == EOF) return(0);
		if (len==MAXLINE) 
		{
			printf ("Input line too long.\n");
			continue; 
		}
	if ((ep=iparse(line,pv,&next)) != NULL) printf("%s",ep) ;
	else
		{
			pv[next] = NULL ;
			iexec(pv) ;
		}
	}
}

/* set abrt to IABORT on interrupt signal */

sabrti ()
{
	abrt = IABORT; 
	signal (SIGINT, sabrti) ;
	return(0) ;
}

/* set abrt to OSABORT on quit signal */

sabrtos ()
{
	abrt = OSABORT ;
	signal(SIGQUIT, sabrtos);
	return(0);
}

/* Get a line from file pointer fp and put in s. Returns length
   of line or EOF. */

getline (fp, s, lim)
FILE *fp;
char s[];
register int lim;
{
	register int c,i;
	i=0;
	while (lim-- > 0)
	{ 
		if ((c=getc(fp)) == EOF) return (EOF);
		s[i++] = c ;
		if ( c == '\n' )
		{ 
			s[i] = '\0' ;
			return ( i ) ;
		}
	}

/* scan to end of line to prevent excess characters from
   appearing as next line . */

	while (!((c = getchar()) == EOF || c == '\n')) ;
	return ( i ) ;
}
